# sservice completion

_vs_cmds() {
  echo -e "help\nrestart\nshutdown\nstart\nrename\nmigrate\nmove\nsave"
  echo -e "list\ninfo\nedit\nset\nconsole\ndiff\ndestroy\nreset\nkill"
  echo -e "install\ndefine"
}

_vs_guest_list() {
  virsh list --all --name
  echo "$@"
}

_vs() {
	COMPREPLY=()
	cur=${COMP_WORDS[COMP_CWORD]}
	prev="${COMP_WORDS[COMP_CWORD-1]}"
	if [ "${COMP_CWORD}" = "1" ]; then
		COMPREPLY=( $(compgen -W "$(_vs_cmds)" -- $cur) )
		return 0
	fi
	case "${COMP_WORDS[1]}" in
		start|stop|restart|shutdown|migrate|move|save|edit|console|con|c|diff|destroy|reset|kill|rename)
                        COMPREPLY=( $(compgen -W "$(_vs_guest_list)" -- $cur) )
			return 0
			;;
		set)
			echo $COMP_CWORD >> /tmp/1
			if [ "$COMP_CWORD" = "2" ]; then
				COMPREPLY=( $(compgen -W "mem cpu boot" -- $cur) )
			elif [ "$COMP_CWORD" = "3" ]; then
	                        COMPREPLY=( $(compgen -W "$(_vs_guest_list)" -- $cur) )
	                fi
			return 0
			;;
		list)
			COMPREPLY=(--all)
			return 0
			;;
		info|i)
			COMPREPLY=( $(compgen -W "$(_vs_guest_list) --all" -- $cur) )
			return 0
			;;
		define)
			COMPREPLY=( $(compgen -f -- $cur) )
			return 0
			;;
	esac
}
complete -o filenames -F _vs vs
